//+------------------------------------------------------------------+
//|                                               price cross ma mq4 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 LimeGreen
#property indicator_width1 2

//
//
//
//
//

extern int    MaPeriod             = 50;
extern int    MAMethod             = MODE_LWMA;
extern int    MAPrice              = PRICE_CLOSE;

extern string note                 = "turn on Alert = true; turn off = false";
extern bool   alertsOn             = true;
extern bool   alertsOnCurrent      = true;
extern bool   alertsMessage        = true;
extern bool   alertsSound          = false;
extern bool   alertsEmail          = false;
extern string soundfile            = "alert2.wav";

//
//
//
//
//

double ma[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
      SetIndexBuffer(0, ma);
      SetIndexBuffer(1, trend);
   
   IndicatorShortName(" price cross Ma ");
return(0);       
}

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int limit,i;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      ma[i] = iMA(NULL,0,MaPeriod,0,MAMethod,MAPrice,i);
      trend[i] = trend[i+1];
         if (Close[i] > ma[i]) trend[i] = 1;
         if (Close[i] < ma[i]) trend[i] =-1;
     }
      
    //
    //
    //
    //
    //
      
    if (alertsOn)
    {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1;
         
     if (trend[whichBar] != trend[whichBar+1])
     if (trend[whichBar] == 1)
           doAlert("Buy");
     else  doAlert("Sell");       
   }

return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," price cross ma ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," price cross ma "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}




